package com.inca.npbusi.sales.bms_sa_con;

import com.inca.np.auth.Userruninfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.DeleteHelper;
import com.inca.np.util.InsertHelper;
import com.inca.np.util.SelectHelper;
import com.inca.np.util.UpdateHelper;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.NptrDBHelper;
import com.inca.pubsrv.ObjectUtils;
import com.inca.zx.pubmethod.ZXCheckMethod;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import org.apache.log4j.Category;

public class WebSaConCreateMvData {
   private static Category a = Category.getInstance(WebSaConCreateMvData.class);

   public static String creMvData(Connection var0, Userruninfo var1, DBTableModel var2, String var3, String var4) {
      new ArrayList();
      String var5 = var2.getItemValue(0, "conid");
      InsertHelper var6 = new InsertHelper("bms_mv_doc");
      String var11 = NpbusiDBHelper.getSeqValue(var0, "BMS_MV_DOC_SEQ");
      var6.bindParam("moveid", var11);
      var6.bindDateParam("credate", NpbusiDBHelper.getSysdate(var0));
      var6.bindParam("mvdir", "0");
      var6.bindParam("usestatus", "2");
      var6.bindParam("inputmanid", var1.getUserid());
      var6.bindParam("delivermethod", "0");
      var6.bindParam("entryid", var1.getEntryid());
      var6.bindParam("printflag", "0");
      var6.bindParam("tranmethod", "7");
      String var7 = var11;
      InsertHelper var10 = var6;
      String var12 = var2.getItemValue(0, "customid");
      String var13 = var2.getItemValue(0, "storageid");
      String var14 = var2.getItemValue(0, "conid");
      String var15 = var2.getItemValue(0, "targetposid");
      String var16 = "select phystoreid from bms_st_def where storageid=?";
      if (ObjectUtils.isNULL(var2 = ZXCheckMethod.getModelBySql(var0, var16, new Object[]{var13}))) {
         throw new Exception(String.format("源保管帐(%s)不存在", var13));
      } else {
         var11 = var2.getItemValue(0, "phystoreid");
         var16 = "select storageid,phystoreid from bms_st_def where customid=? and entryid=?";
         if (ObjectUtils.isNULL(var2 = ZXCheckMethod.getModelBySql(var0, var16, new Object[]{var12, var1.getEntryid()}))) {
            throw new Exception(String.format("生成移库单失败：客户(%s)没有目标保管帐", var12));
         } else {
            String var21 = var2.getItemValue(0, "storageid");
            String var20 = var2.getItemValue(0, "phystoreid");
            var16 = "select tranposid transiteid from bms_tr_pos_def_v where usestatus=1  and companyid=? and entryid=?";
            ZXCheckMethod.getModelBySql(var0, var16, new Object[]{var12, var1.getEntryid()});
            var10.bindParam("fromstorageid", var13);
            var10.bindParam("fromcompanyid", var11);
            var10.bindParam("tostorageid", var21);
            var10.bindParam("tocompanyid", var20);
            var10.bindParam("transiteid", var15);
            var10.bindParam("websourceid", var14);
            var10.bindParam("memo", String.format("订单来自“网上订单管理-------->销售订单管理(%s)”", var14));
            var10.executeInsert(var0);
            SelectHelper var22;
            (var22 = new SelectHelper(" select b.*,  a.lotid,  a.batchid,  a.posid,  a.dtlgoodsqty,  a.storageid,  a.congoodsdtlid,  a.goodsstatusid  from bms_sa_con_goodsdtl a,bms_sa_con_dtl b where a.condtlid=b.condtlid  and b.conid=?  and nvl(a.execflag, 0) <> 1  for update")).bindParam(var5);
            DBTableModel var23;
            if ((var23 = var22.executeSelect(var0, 0, 1000)) != null && var23.getRowCount() > 0) {
               UpdateHelper var19;
               if (a(var0, var1, var23, var7, var3)) {
                  (new DeleteHelper("delete from bms_mv_doc where moveid=" + var7)).executeDelete(var0);
               } else {
                  String var17 = "select count(1) ct from bms_mv_dtl a where a.moveid=?";
                  SelectHelper var18;
                  (var18 = new SelectHelper(var17)).bindParam(var7);
                  var20 = var18.executeSelect(var0, 0, 1).getItemValue(0, "ct");
                  var17 = "update bms_mv_doc a set a.dtl_lines=? where a.moveid=?";
                  (var19 = new UpdateHelper(var17)).bindParam(var20);
                  var19.bindParam(var7);
                  var19.executeUpdate(var0);
               }

               if (var4 != null && "1".equals(var4)) {
                  (var19 = new UpdateHelper("update bms_sa_con_doc a set a.usestatus = 3 where a.conid = ? and not exists(select 1 from bms_sa_con_dtl x where x.conid=a.conid and nvl(x.invalidflag,0)<>1 and nvl(x.usestatus,0)<>1)")).bindParam(var5);
                  var19.executeUpdate(var0);
               } else {
                  (var19 = new UpdateHelper("update bms_sa_con_doc set usestatus = 3 where conid = ?")).bindParam(var5);
                  var19.executeUpdate(var0);
               }

               return var7;
            } else {
               throw new Exception("ID为" + var5 + "的销售订单细单没有找到！");
            }
         }
      }
   }

   private static boolean a(Connection var0, Userruninfo var1, DBTableModel var2, String var3, String var4) {
      boolean var5 = true;

      for(int var6 = 0; var2 != null && var6 < var2.getRowCount(); ++var6) {
         String var7 = var2.getItemValue(var6, "condtlid");
         String var8 = var2.getItemValue(var6, "congoodsdtlid");
         String var9 = var2.getItemValue(var6, "websourceid");
         String var10 = var2.getItemValue(var6, "websourcedocid");
         InsertHelper var11 = new InsertHelper("bms_mv_dtl");
         String var12 = NpbusiDBHelper.getSeqValue(var0, "BMS_MV_DTL_SEQ");
         var11.bindParam("movedtlid", var12);
         var11.bindParam("costcalcflag", "1");
         var11.bindParam("invalidflag", "0");
         var11.bindParam("stiflag", "0");
         var11.bindParam("stoflag", "0");
         String var13 = var2.getItemValue(var6, "invalidflag");
         if (!"1".equals(var13) && (var13 = var2.getItemValue(var6, "dtlgoodsqty")) != null && DecimalHelper.comparaDecimal("0", var13) != 0) {
            String var14 = var2.getItemValue(var6, "unitprice");
            if (!"".equals(var14) && DecimalHelper.toDec(var14).compareTo(new BigDecimal("0")) > 0) {
               String var25 = var2.getItemValue(var6, "goodsid");
               var14 = var2.getItemValue(var6, "batchid");
               String var15 = var2.getItemValue(var6, "lotid");
               String var16 = var2.getItemValue(var6, "posid");
               String var17 = var2.getItemValue(var6, "goodsdtlid");
               String var18 = var2.getItemValue(var6, "goodsstatusid");
               String var19 = var2.getItemValue(var6, "dtlgoodsqty");
               String var20 = var2.getItemValue(var6, "goodsuseunit");
               String var21;
               if ((var21 = var2.getItemValue(var6, "usepacksize")) == null || var21.trim().length() == 0) {
                  var21 = "1";
               }

               var21 = DecimalHelper.divide(var19, var21, 2);
               String var22 = var2.getItemValue(var6, "priceid");
               String var23 = var2.getItemValue(var6, "unitprice");
               String var24 = var2.getItemValue(var6, "total_line");
               var11.bindParam("moveid", var3);
               var11.bindParam("goodsid", var25);
               var11.bindParam("batchid", var14);
               var11.bindParam("lotid", var15);
               var11.bindParam("posid", var16);
               var11.bindParam("goodsdtlid", var17);
               var11.bindParam("goodsstatusid", var18);
               var11.bindParam("goodsqty", var19);
               var11.bindParam("goodsuseunit", var20);
               var11.bindParam("goodsuseqty", var21);
               var11.bindParam("zx_priceid", var22);
               var11.bindParam("zx_unitprice", var23);
               var11.bindParam("zx_money", var24);
               var11.bindParam("websourceid", var9);
               var11.bindParam("websourcedocid", var10);
               var11.bindParam("condtlid", var7);
               var11.bindParam("dtlmemo", String.format("“网上订单合并管理----------->销售订单发货(%S)”生成", var8));
               var11.executeInsert(var0);
               (var11 = new InsertHelper("web_dd_to_mv")).bindParam("websacondtlid", var9);
               var11.bindParam("mvdtlid", var12);
               var11.bindParam("sacondtlid", var7);
               var11.executeInsert(var0);
               a(var0, "-1", var8);
               var25 = NptrDBHelper.genstout(var0, "6", var12);
               if (!NptrDBHelper.autofix(var0, var25, var1, "")) {
                  throw new Exception(String.format("库存不足，生成临时出库单失败!订单细单%s/明细%s", var7, var8));
               }

               UpdateHelper var26;
               (var26 = new UpdateHelper("update bms_sa_con_dtl set accstqty = nvl(accstqty,0)+? where condtlid = ?")).bindParam(var13);
               var26.bindParam(var7);
               var26.executeUpdate(var0);
               (var26 = new UpdateHelper("update bms_sa_con_dtl  set usestatus = 1 where condtlid =? AND nvl(accstqty,0) >=goodsqty")).bindParam(var7);
               var26.executeUpdate(var0);
               (var26 = new UpdateHelper("update bms_sa_con_goodsdtl v set v.execflag=1  where v.congoodsdtlid=?")).bindParam(var8);
               var26.executeUpdate(var0);
               var25 = null;
               var25 = null;
               var25 = null;
               if ("1".equals(var4)) {
                  if (var9 != null && var9.trim().length() > 0) {
                     var25 = "update web_sa_con_dtl set usestatus = 41 where websacondtlid =?";
                     (var26 = new UpdateHelper(var25)).bindParam(var9);
                     var26.executeUpdate(var0);
                  }
               } else if (var9 != null && var9.trim().length() > 0) {
                  var25 = "update web_sa_con_dtl set usestatus = 32 where websacondtlid =?";
                  (var26 = new UpdateHelper(var25)).bindParam(var9);
                  var26.executeUpdate(var0);
               }

               if (var10 != null && var10.trim().length() > 0) {
                  var25 = " select nvl(sum(decode(a.usestatus, 41, 1, 0)), 0) route,  nvl(sum(decode(a.usestatus, 32, 1, 0)), 0) prepare,  nvl(count(a.websacondtlid), 0) dtlcount  from web_sa_con_dtl a  where a.websacondocid = ? and nvl(a.usestatus,-2)<>3 and nvl(a.usestatus,-2)<>-1 ";
                  SelectHelper var27;
                  (var27 = new SelectHelper(var25)).bindParam(var10);
                  DBTableModel var28;
                  if ((var28 = var27.executeSelect(var0, 0, 1)) != null && var28.getRowCount() > 0) {
                     var7 = var28.getItemValue(0, "route");
                     var8 = var28.getItemValue(0, "prepare");
                     var25 = var28.getItemValue(0, "dtlcount");
                     if (DecimalHelper.comparaDecimal(var7, "0") == 0) {
                        if (DecimalHelper.comparaDecimal(var8, "0") > 0 && DecimalHelper.comparaDecimal(var8, var25) < 0) {
                           var25 = "update web_sa_con_doc set usestatus = 12 where websacondocid =?";
                           (var26 = new UpdateHelper(var25)).bindParam(var10);
                           var26.executeUpdate(var0);
                        } else if (DecimalHelper.comparaDecimal(var8, "0") > 0 && DecimalHelper.comparaDecimal(var8, var25) == 0) {
                           var25 = "update web_sa_con_doc set usestatus = 32 where websacondocid =?";
                           (var26 = new UpdateHelper(var25)).bindParam(var10);
                           var26.executeUpdate(var0);
                        }
                     }
                  }
               }

               var5 = false;
            }
         }
      }

      return var5;
   }

   private static void a(Connection var0, String var1, String var2) {
      PreparedStatement var3 = null;
      ResultSet var4 = null;
      PreparedStatement var5 = null;
      ResultSet var6 = null;
      PreparedStatement var7 = null;
      var6 = null;
      PreparedStatement var8 = null;
      String var9 = null;
      var9 = null;
      String var10 = "";

      try {
         var9 = "select * from bms_st_io_doc_tmp where comefrom = ? and sourceid = ? for update";
         (var3 = var0.prepareStatement(var9)).setString(1, var1);
         var3.setString(2, var2);
         if (!(var4 = var3.executeQuery()).next()) {
            throw new Exception("没有找到对应的临时出库总单或临时出库单正在记账！");
         }

         var9 = "select * from bms_st_io_dtl_tmp where inoutid in (select inoutid from bms_st_io_doc_tmp where comefrom = ? and sourceid = ?)";
         (var5 = var0.prepareStatement(var9)).setString(1, var1);
         var5.setString(2, var2);
         if (!(var6 = var5.executeQuery()).next()) {
            throw new Exception("没有找到对应的临时出库细单或临时出库单正在记账！");
         }

         var6.close();
         var5.close();
         var9 = "select * from bms_tr_dtl where trdtlid in (select trdtlid from bms_st_io_doc_tmp where comefrom = ? and sourceid = ?) for update";
         (var7 = var0.prepareStatement(var9)).setString(1, var1);
         var7.setString(2, var2);
         ResultSet var16;
         if ((var6 = var7.executeQuery()).next()) {
            var10 = var6.getString("trid");
            var9 = "select * from bms_tr_doc where trid = ? for update";
            (var8 = var0.prepareStatement(var9)).setString(1, var10);
            if (!(var16 = var8.executeQuery()).next()) {
               throw new Exception("没有找到调度总单！");
            }

            var16.close();
            var8.close();
         }

         var6.close();
         var7.close();

         do {
            var1 = var4.getString("trdtlid");
            var2 = var4.getString("inoutid");
            var9 = "delete from bms_st_io_dtl_tmp where inoutid = ?";
            (var8 = var0.prepareStatement(var9)).setString(1, var2);
            var8.execute();
            var8.close();
            var9 = "delete from bms_st_io_doc_tmp where inoutid = ?";
            (var8 = var0.prepareStatement(var9)).setString(1, var2);
            var8.execute();
            var8.close();
            if (var1 != null && !var1.equals("")) {
               var9 = "select count(*) from bms_st_io_doc where trdtlid = ?";
               (var8 = var0.prepareStatement(var9)).setString(1, var1);
               (var16 = var8.executeQuery()).next();
               var2 = var16.getString(1);
               var16.close();
               var8.close();
               var9 = "select count(*) from bms_st_io_doc_tmp where trdtlid = ?";
               (var8 = var0.prepareStatement(var9)).setString(1, var1);
               (var16 = var8.executeQuery()).next();
               String var15 = var16.getString(1);
               var16.close();
               var8.close();
               if (var2.equals("0") && var15.equals("0")) {
                  var9 = "delete from bms_tr_dtl where trdtlid = ?";
                  (var8 = var0.prepareStatement(var9)).setString(1, var1);
                  var8.execute();
                  var8.close();
               }

               var9 = "select count(*) from bms_tr_dtl where trid = ?";
               (var8 = var0.prepareStatement(var9)).setString(1, var10);
               (var16 = var8.executeQuery()).next();
               var2 = var16.getString(1);
               var16.close();
               var8.close();
               if (var2.equals("0")) {
                  var9 = "delete from bms_tr_doc where trid = ?";
                  (var8 = var0.prepareStatement(var9)).setString(1, var10);
                  var8.execute();
                  var8.close();
               }
            }
         } while(var4.next());
      } catch (Exception var13) {
         a.error("error", var13);
         throw var13;
      } finally {
         if (var3 != null) {
            var3.close();
         }

         if (var5 != null) {
            var5.close();
         }

         if (var7 != null) {
            var7.close();
         }

         if (var8 != null) {
            var8.close();
         }

      }

   }
}
